package com.hai.enum_type;

import java.util.Objects;

public enum CarTypeEnum {
    CarType0(0 , "蓝;"),
    CarType1(1 , "黄"),
    CarType2(2 , "黑"),
    CarType3(3 , "白"),
    CarType4(4 , "渐变绿"),
    CarType5(5 , "黄绿双拼"),
    CarType6(6 ,"蓝白渐变"),
    ;

    private Integer  type;
    private String name;


    CarTypeEnum(int type , String name) {
        this.type = type;
        this.name = name;
    }

    public static String getNameByType(Integer type) {
        for (CarTypeEnum ele : values()) {
            if(Objects.equals(type,ele.getType())) return ele.getName();
        }
        return null;
    }
    public static Integer getNameByName(String name) {
        for (CarTypeEnum ele : values()) {
            if(Objects.equals(name,ele.getName())) return ele.getType();
        }
        return null;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
